tabella = [[5, 3, 0, 0, 7, 0, 0, 0, 0],
            [6, 0, 0, 1, 9, 5, 0, 0, 0],
            [0, 9, 8, 0, 0, 0, 0, 6, 0],
            [8, 0, 0, 0, 6, 0, 0, 0, 3],
            [4, 0, 0, 8, 0, 3, 0, 0, 1],
            [7, 0, 0, 0, 2, 0, 0, 0, 6],
            [0, 6, 0, 0, 0, 0, 2, 8 ,0],
            [0, 0, 0, 4, 1, 9, 0, 0, 5],
            [0, 0, 0, 0, 8, 0, 0, 7, 9]]


def stampa_sudoku(tabella):
  for i in range(0, 9):
    for j in range(0, 9):
      if tabella[i][j] == 0:
        print("_ ", end="")
      else:
        print(str(tabella[i][j]) + " ", end="")
    print()

def possibile(tabella, riga, colonna, n):
  # Se la posizione è occupata allora non è
  # possibile inserire il numero
  if tabella[riga][colonna] != 0:
    return False
  # Controllo di righe e colonne
  for i in range(0, 9):
    if tabella[i][colonna] == n:
      return False
    if tabella[riga][i] == n:
      return False
  # Controllo del quadrato
  min_riga = 3 * (riga//3)
  min_colonna = 3 * (colonna//3)
  for i in range(min_riga, min_riga+3):
    for j in range(min_colonna, min_colonna+3):
      if tabella[i][j] == n:
        return False
  return True


def risolvi(tabella):
  for i in range(0, 9):
    for j in range(0, 9):
      if tabella[i][j] == 0:
        for scelta in range(1, 10):
          if possibile(tabella, i, j, scelta):
            tabella[i][j] = scelta
            risolvi(tabella)
            tabella[i][j] = 0
        return
  stampa_sudoku(tabella)
  input()


risolvi(tabella)
